with OCI.Thick.Statements;
package OCI.Thick.Binds is

   use Statements;

   type Abstract_Bind is abstract tagged private;

   procedure Clear_Value (Var : in out Abstract_Bind'Class);
   function Is_Null (Var : Abstract_Bind'Class) return Boolean;
   
private

   procedure Destroy (Object : in out Abstract_Bind);

   procedure Bind (
       Stmt : Statement;
       Var : in out Abstract_Bind'Class;
       Name : String;
       Type_Id : Ub2; Value : DVoid; Size : Sb4);

   type Abstract_Bind is abstract 
   new RF.Controlled_Reference with 
   record
      Indicator : A_Sb2 := new Sb2'(Null_Indicator);
      Bind     : aliased OCIBind := OCIBind (Empty_Handle);
      Stmt : Statement;
   end record;

end OCI.Thick.Binds;