------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information are in the file oci.ads    --
------------------------------------------------------------------------------
with OCI.Lib;
package oci.EnvCreate80 is
   use OCI.Lib;

   function OCIEnvCreate (
      Envh : access OCIEnv;
      Mode : Ub4;
      Ctxp : Undefined := Empty;
      Malocfp : Undefined := Empty;
      Ralocfp : Undefined := Empty;
      Mfreefp : Undefined := Empty;
      Xtramemsz : Undefined := Empty;
      Usrmempp  : Undefined := Empty) return SWord;

   pragma Export (C, OCIEnvCreate, "OCIEnvCreate");

   Not_Implemented_in_this_version : exception;
    
   function OCILOBCREATETEMPORARY (svchp   : OCISvcCtx;
                                   errhp   : OCIError;
                                   locp    : OCILobLocator;
                                   csid    : Ub2;
                                   csfrm   : Ub1;
                                   lobtype : Ub1;
                                   cache   : C.int;
                                   duration : OCIDuration)
                                             return SWord;
   function Not_Implemented_2 return SWord;
    
   pragma Export (C, OCILobCreateTemporary, "OCILobCreateTemporary");
   pragma Export (C, Not_Implemented_2, "OCILobFreeTemporary");
                                             
end oci.EnvCreate80;